#!/bin/bash

usbdir=/mnt/usb
usbdevice=/dev/sdb1
bldir=/mnt/bl
bldevice=/dev/sdc

if test -f ${usbdir}/nomount;
then
	echo "Installing from premounted directory..."
elif test -e ${usbdevice};
then
	mkdir -p ${usbdir}
	sleep 1
	if mount ${usbdevice} ${usbdir};
	then
		echo "Source mount successful."
	else
		exit 1
	fi
else
	exit 2
fi

if test -f ${bldir}/nomount;
then
	echo "Installing to premounted directory..."
elif test -e ${bldevice};
then
	mkdir -p ${bldir}
	sleep 1
	if mount ${bldevice} ${bldir};
	then
		echo "Target mount successful."
		sleep 2
	else
		exit 1
	fi
else
	exit 2
fi

echo "Scanning for firmware update from source..."
cd ${usbdir}
uf2file=`ls -t *.uf2 | head -n1`
if [ -f "${uf2file}" ]; then
	echo "Copying ${uf2file} to ${bldir}..."
	cp -p ${uf2file} ${bldir}
	if [ $? -eq 0 ]; then
		exit_code=0
	else
		exit_code=4
	fi
else
	exit_code=3
fi
echo "Firmware update check complete."

umount ${usbdir}
umount ${bldir}

exit ${exit_code}
